/* attention, this file was automatically generated by swig and Perl scripts */
#include "drv_optic_api.h"
#include "drv_optic_std_defs.h"
#include "drv_optic_error.h"
#include "drv_optic_cli_core.h"
#include "drv_optic_interface.h"
#include "drv_optic_goi_interface.h"
#include "drv_optic_fcsi_interface.h"
#include "drv_optic_mm_interface.h"
#include "drv_optic_mpd_interface.h"
#include "drv_optic_bert_interface.h"
#include "drv_optic_omu_interface.h"
#include "drv_optic_bosa_interface.h"
#include "drv_optic_cal_interface.h"
#include "drv_optic_dcdc_apd_interface.h"
#include "drv_optic_dcdc_core_interface.h"
#include "drv_optic_dcdc_ddr_interface.h"
#include "drv_optic_ldo_interface.h"

#ifdef INCLUDE_CLI_SUPPORT

extern int optic_cli_check_help(
	const char *p_cmd,
	const char *p_usage,
	const uint32_t bufsize_max,
	char *p_out);

/** \addtogroup OPTIC_CLI_COMMANDS
   @{
*/

#if defined(INCLUDE_DEBUG_SUPPORT)
/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_debuglevel_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_debuglevel param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_debuglevel_set" OPTIC_CRLF
		"Short Form: opticds" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t level" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu", &param.level);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = optic_debuglevel_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_debuglevel_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_debuglevel param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_debuglevel_get" OPTIC_CRLF
		"Short Form: opticdg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t level" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = optic_debuglevel_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d level=%u " OPTIC_CRLF, (int)fct_ret, param.level);
}

#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_version_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_versionstring param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_version_get" OPTIC_CRLF
		"Short Form: opticvg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- char version[80]" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = optic_version_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d version=\"%s\" " OPTIC_CRLF, (int)fct_ret, param.version);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_register_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_reg_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_register_set" OPTIC_CRLF
		"Short Form: opticrs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t form" OPTIC_CRLF
		"- ulong_t address" OPTIC_CRLF
		"- uint32_t value" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %lu %u", &param.form, &param.address, &param.value);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = optic_register_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_register_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_reg_get_in param_in;
	struct optic_reg_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_register_get" OPTIC_CRLF
		"Short Form: opticrg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t form" OPTIC_CRLF
		"- ulong_t address" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t form" OPTIC_CRLF
		"- uint32_t value" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %lu", &param_in.form, &param_in.address);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = optic_register_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d form=%u value=0x%x " OPTIC_CRLF, (int)fct_ret, param_out.form, param_out.value);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_reset(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_reset" OPTIC_CRLF
		"Short Form: opticr" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = optic_reset(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_reconfig(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_reconfig" OPTIC_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = optic_reconfig(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_optic_mode_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mode param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: optic_mode_set" OPTIC_CRLF
		"Short Form: opticms" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_manage_mode mode" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.mode);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = optic_mode_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_init(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_init" OPTIC_CRLF
		"Short Form: goii" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_init(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_goi_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_cfg_set" OPTIC_CRLF
		"Short Form: goics" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature_check_time" OPTIC_CRLF
		"- uint8_t temperature_thres_mpdcorr" OPTIC_CRLF
		"- uint16_t update_laser_age" OPTIC_CRLF
		"- uint32_t laser_age" OPTIC_CRLF
		"- uint16_t delay_tx_enable" OPTIC_CRLF
		"- uint16_t delay_tx_disable" OPTIC_CRLF
		"- uint16_t size_tx_fifo" OPTIC_CRLF
		"- uint16_t temp_ref" OPTIC_CRLF
		"- bool rx_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool bias_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool mod_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t temp_alarm_yellow_set" OPTIC_CRLF
		"- uint16_t temp_alarm_yellow_clear" OPTIC_CRLF
		"- uint16_t temp_alarm_red_set" OPTIC_CRLF
		"- uint16_t temp_alarm_red_clear" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %bu %hu %u %hu %hu %hu %hu %bu %bu %bu %hu %hu %hu %hu", &param.temperature_check_time, &param.temperature_thres_mpdcorr, &param.update_laser_age, &param.laser_age, &param.delay_tx_enable, &param.delay_tx_disable, &param.size_tx_fifo, &param.temp_ref, &param.rx_polarity_regular, &param.bias_polarity_regular, &param.mod_polarity_regular, &param.temp_alarm_yellow_set, &param.temp_alarm_yellow_clear, &param.temp_alarm_red_set, &param.temp_alarm_red_clear);
	if (ret != 15) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = goi_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_goi_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_cfg_get" OPTIC_CRLF
		"Short Form: goicg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t temperature_check_time" OPTIC_CRLF
		"- uint8_t temperature_thres_mpdcorr" OPTIC_CRLF
		"- uint16_t update_laser_age" OPTIC_CRLF
		"- uint32_t laser_age" OPTIC_CRLF
		"- uint16_t delay_tx_enable" OPTIC_CRLF
		"- uint16_t delay_tx_disable" OPTIC_CRLF
		"- uint16_t size_tx_fifo" OPTIC_CRLF
		"- uint16_t temp_ref" OPTIC_CRLF
		"- bool rx_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool bias_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool mod_polarity_regular \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t temp_alarm_yellow_set" OPTIC_CRLF
		"- uint16_t temp_alarm_yellow_clear" OPTIC_CRLF
		"- uint16_t temp_alarm_red_set" OPTIC_CRLF
		"- uint16_t temp_alarm_red_clear" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d temperature_check_time=%hu temperature_thres_mpdcorr=%u update_laser_age=%hu laser_age=%u delay_tx_enable=%hu delay_tx_disable=%hu size_tx_fifo=%hu temp_ref=%hu rx_polarity_regular=%u bias_polarity_regular=%u mod_polarity_regular=%u temp_alarm_yellow_set=%hu temp_alarm_yellow_clear=%hu temp_alarm_red_set=%hu temp_alarm_red_clear=%hu " OPTIC_CRLF, (int)fct_ret, param.temperature_check_time, param.temperature_thres_mpdcorr, param.update_laser_age, param.laser_age, param.delay_tx_enable, param.delay_tx_disable, param.size_tx_fifo, param.temp_ref, param.rx_polarity_regular, param.bias_polarity_regular, param.mod_polarity_regular, param.temp_alarm_yellow_set, param.temp_alarm_yellow_clear, param.temp_alarm_red_set, param.temp_alarm_red_clear);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_range_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_range_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_range_cfg_set" OPTIC_CRLF
		"Short Form: goircs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t tabletemp_extcorr_min" OPTIC_CRLF
		"- uint16_t tabletemp_extcorr_max" OPTIC_CRLF
		"- uint16_t tabletemp_extnom_min" OPTIC_CRLF
		"- uint16_t tabletemp_extnom_max" OPTIC_CRLF
		"- uint16_t tabletemp_intcorr_min" OPTIC_CRLF
		"- uint16_t tabletemp_intcorr_max" OPTIC_CRLF
		"- uint16_t tabletemp_intnom_min" OPTIC_CRLF
		"- uint16_t tabletemp_intnom_max" OPTIC_CRLF
		"- uint16_t ibias_max" OPTIC_CRLF
		"- uint16_t imod_max" OPTIC_CRLF
		"- uint16_t ibiasimod_max" OPTIC_CRLF
		"- uint8_t intcoeff_max[2]" OPTIC_CRLF
		"- uint16_t vapd_min" OPTIC_CRLF
		"- uint16_t vapd_max" OPTIC_CRLF
		"- uint8_t sat_min" OPTIC_CRLF
		"- uint8_t sat_max" OPTIC_CRLF
		"- uint16_t vcore_min" OPTIC_CRLF
		"- uint16_t vcore_max" OPTIC_CRLF
		"- uint16_t vddr_min" OPTIC_CRLF
		"- uint16_t vddr_max" OPTIC_CRLF
		"- uint16_t oc_imod_thr" OPTIC_CRLF
		"- uint16_t oc_ibias_thr" OPTIC_CRLF
		"- uint16_t oc_ibias_imod_thr" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu %hu %hu %hu %hu %hu %hu %hu %hu %hu %bu[2] %hu %hu %bu %bu %hu %hu %hu %hu %hu %hu %hu", &param.tabletemp_extcorr_min, &param.tabletemp_extcorr_max, &param.tabletemp_extnom_min, &param.tabletemp_extnom_max, &param.tabletemp_intcorr_min, &param.tabletemp_intcorr_max, &param.tabletemp_intnom_min, &param.tabletemp_intnom_max, &param.ibias_max, &param.imod_max, &param.ibiasimod_max, &param.intcoeff_max[0], &param.vapd_min, &param.vapd_max, &param.sat_min, &param.sat_max, &param.vcore_min, &param.vcore_max, &param.vddr_min, &param.vddr_max, &param.oc_imod_thr, &param.oc_ibias_thr, &param.oc_ibias_imod_thr);
	if (ret != 24) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = goi_range_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_range_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_range_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_range_cfg_get" OPTIC_CRLF
		"Short Form: goircg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t tabletemp_extcorr_min" OPTIC_CRLF
		"- uint16_t tabletemp_extcorr_max" OPTIC_CRLF
		"- uint16_t tabletemp_extnom_min" OPTIC_CRLF
		"- uint16_t tabletemp_extnom_max" OPTIC_CRLF
		"- uint16_t tabletemp_intcorr_min" OPTIC_CRLF
		"- uint16_t tabletemp_intcorr_max" OPTIC_CRLF
		"- uint16_t tabletemp_intnom_min" OPTIC_CRLF
		"- uint16_t tabletemp_intnom_max" OPTIC_CRLF
		"- uint16_t ibias_max" OPTIC_CRLF
		"- uint16_t imod_max" OPTIC_CRLF
		"- uint16_t ibiasimod_max" OPTIC_CRLF
		"- uint8_t intcoeff_max[2]" OPTIC_CRLF
		"- uint16_t vapd_min" OPTIC_CRLF
		"- uint16_t vapd_max" OPTIC_CRLF
		"- uint8_t sat_min" OPTIC_CRLF
		"- uint8_t sat_max" OPTIC_CRLF
		"- uint16_t vcore_min" OPTIC_CRLF
		"- uint16_t vcore_max" OPTIC_CRLF
		"- uint16_t vddr_min" OPTIC_CRLF
		"- uint16_t vddr_max" OPTIC_CRLF
		"- uint16_t oc_imod_thr" OPTIC_CRLF
		"- uint16_t oc_ibias_thr" OPTIC_CRLF
		"- uint16_t oc_ibias_imod_thr" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_range_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tabletemp_extcorr_min=%hu tabletemp_extcorr_max=%hu tabletemp_extnom_min=%hu tabletemp_extnom_max=%hu tabletemp_intcorr_min=%hu tabletemp_intcorr_max=%hu tabletemp_intnom_min=%hu tabletemp_intnom_max=%hu ibias_max=%hu imod_max=%hu ibiasimod_max=%hu intcoeff_max=\"%u %u\" vapd_min=%hu vapd_max=%hu sat_min=%u sat_max=%u vcore_min=%hu vcore_max=%hu vddr_min=%hu vddr_max=%hu oc_imod_thr=%hu oc_ibias_thr=%hu oc_ibias_imod_thr=%hu " OPTIC_CRLF, (int)fct_ret, param.tabletemp_extcorr_min, param.tabletemp_extcorr_max, param.tabletemp_extnom_min, param.tabletemp_extnom_max, param.tabletemp_intcorr_min, param.tabletemp_intcorr_max, param.tabletemp_intnom_min, param.tabletemp_intnom_max, param.ibias_max, param.imod_max, param.ibiasimod_max, param.intcoeff_max[0], param.intcoeff_max[1], param.vapd_min, param.vapd_max, param.sat_min, param.sat_max, param.vcore_min, param.vcore_max, param.vddr_min, param.vddr_max, param.oc_imod_thr, param.oc_ibias_thr, param.oc_ibias_imod_thr);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_status_get" OPTIC_CRLF
		"Short Form: goisg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t goi_ready" OPTIC_CRLF
		"- uint8_t mode" OPTIC_CRLF
		"- bool rx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool tx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_signal \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d goi_ready=%u mode=%u rx_enable=%u tx_enable=%u loss_of_signal=%u " OPTIC_CRLF, (int)fct_ret, param.goi_ready, param.mode, param.rx_enable, param.tx_enable, param.loss_of_signal);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_ext_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_ext_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_ext_status_get" OPTIC_CRLF
		"Short Form: goiesg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t chip" OPTIC_CRLF
		"- uint8_t fuse_format" OPTIC_CRLF
		"- uint8_t state_history[10]" OPTIC_CRLF
		"- uint8_t table_read[9]" OPTIC_CRLF
		"- uint8_t config_read[11]" OPTIC_CRLF
		"- uint8_t mode" OPTIC_CRLF
		"- int16_t rx_offset" OPTIC_CRLF
		"- uint16_t mod_max" OPTIC_CRLF
		"- uint16_t bias_max" OPTIC_CRLF
		"- bool rx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool tx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t bias_current" OPTIC_CRLF
		"- uint16_t modulation_current" OPTIC_CRLF
		"- uint16_t meas_power_1490_rssi" OPTIC_CRLF
		"- uint16_t meas_power_1550_rssi" OPTIC_CRLF
		"- uint16_t meas_power_1550_rf" OPTIC_CRLF
		"- uint16_t meas_voltage_1490_rssi" OPTIC_CRLF
		"- uint16_t meas_current_1490_rssi" OPTIC_CRLF
		"- bool meas_current_1490_rssi_is_positive \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t meas_voltage_1550_rf" OPTIC_CRLF
		"- uint16_t meas_voltage_1550_rssi" OPTIC_CRLF
		"- bool pll_lock_status \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_signal \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_lock \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool temp_alarm_yellow \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool temp_alarm_red \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_ext_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d chip=%hu fuse_format=%u state_history=\"%u %u %u %u %u %u %u %u %u %u\" table_read=\"%u %u %u %u %u %u %u %u %u\" config_read=\"%u %u %u %u %u %u %u %u %u %u %u\" mode=%u rx_offset=%hd mod_max=%hu bias_max=%hu rx_enable=%u tx_enable=%u bias_current=%hu modulation_current=%hu meas_power_1490_rssi=%hu meas_power_1550_rssi=%hu meas_power_1550_rf=%hu meas_voltage_1490_rssi=%hu meas_current_1490_rssi=%hu meas_current_1490_rssi_is_positive=%u meas_voltage_1550_rf=%hu meas_voltage_1550_rssi=%hu pll_lock_status=%u loss_of_signal=%u loss_of_lock=%u temp_alarm_yellow=%u temp_alarm_red=%u " OPTIC_CRLF, (int)fct_ret, param.chip, param.fuse_format, param.state_history[0], param.state_history[1], param.state_history[2], param.state_history[3], param.state_history[4], param.state_history[5], param.state_history[6], param.state_history[7], param.state_history[8], param.state_history[9], param.table_read[0], param.table_read[1], param.table_read[2], param.table_read[3], param.table_read[4], param.table_read[5], param.table_read[6], param.table_read[7], param.table_read[8], param.config_read[0], param.config_read[1], param.config_read[2], param.config_read[3], param.config_read[4], param.config_read[5], param.config_read[6], param.config_read[7], param.config_read[8], param.config_read[9], param.config_read[10], param.mode, param.rx_offset, param.mod_max, param.bias_max, param.rx_enable, param.tx_enable, param.bias_current, param.modulation_current, param.meas_power_1490_rssi, param.meas_power_1550_rssi, param.meas_power_1550_rf, param.meas_voltage_1490_rssi, param.meas_current_1490_rssi, param.meas_current_1490_rssi_is_positive, param.meas_voltage_1550_rf, param.meas_voltage_1550_rssi, param.pll_lock_status, param.loss_of_signal, param.loss_of_lock, param.temp_alarm_yellow, param.temp_alarm_red);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_video_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_video_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_video_cfg_set" OPTIC_CRLF
		"Short Form: goivcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t video_word" OPTIC_CRLF
		"- bool video_range_low \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %bu", &param.video_word, &param.video_range_low);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = goi_video_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_video_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_video_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_video_cfg_get" OPTIC_CRLF
		"Short Form: goivcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t video_word" OPTIC_CRLF
		"- bool video_range_low \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_video_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d video_word=%hu video_range_low=%u " OPTIC_CRLF, (int)fct_ret, param.video_word, param.video_range_low);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_video_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_video_enable" OPTIC_CRLF
		"Short Form: goive" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_video_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_video_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_video_disable" OPTIC_CRLF
		"Short Form: goivd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_video_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_video_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_video_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_video_status_get" OPTIC_CRLF
		"Short Form: goivsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool video_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = goi_video_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d video_enable=%u " OPTIC_CRLF, (int)fct_ret, param.video_enable);
}

#if defined(INCLUDE_DEBUG_SUPPORT)
/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_goi_mm_interval_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mm_interval_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: goi_mm_interval_cfg_set" OPTIC_CRLF
		"Short Form: goimics" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint32_t measure_interval" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.measure_interval);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = goi_mm_interval_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_fcsi_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_fcsi_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: fcsi_cfg_set" OPTIC_CRLF
		"Short Form: fcsics" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t gvs" OPTIC_CRLF
		"- uint16_t ctrl0" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu", &param.gvs, &param.ctrl0);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = fcsi_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_fcsi_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_fcsi_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: fcsi_cfg_get" OPTIC_CRLF
		"Short Form: fcsicg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t gvs" OPTIC_CRLF
		"- uint16_t ctrl0" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = fcsi_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d gvs=%hu ctrl0=%hu " OPTIC_CRLF, (int)fct_ret, param.gvs, param.ctrl0);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_apd_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_apd_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_apd_cfg_set" OPTIC_CRLF
		"Short Form: dcdcacs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint32_t r_diff[2]" OPTIC_CRLF
		"- uint32_t v_ext" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u[2] %u", &param.r_diff[0], &param.v_ext);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = dcdc_apd_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_apd_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_apd_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_apd_cfg_get" OPTIC_CRLF
		"Short Form: dcdcacg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint32_t r_diff[2]" OPTIC_CRLF
		"- uint32_t v_ext" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_apd_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d r_diff=\"%u %u\" v_ext=%u " OPTIC_CRLF, (int)fct_ret, param.r_diff[0], param.r_diff[1], param.v_ext);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_apd_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_apd_enable" OPTIC_CRLF
		"Short Form: dcdcae" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_apd_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_apd_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_apd_disable" OPTIC_CRLF
		"Short Form: dcdcad" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_apd_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_apd_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_apd_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_apd_status_get" OPTIC_CRLF
		"Short Form: dcdcasg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t target_voltage" OPTIC_CRLF
		"- int16_t voltage" OPTIC_CRLF
		"- int16_t regulation_error" OPTIC_CRLF
		"- uint8_t saturation" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_apd_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d enable=%u target_voltage=%hu voltage=%hd regulation_error=%hd saturation=%u " OPTIC_CRLF, (int)fct_ret, param.enable, param.target_voltage, param.voltage, param.regulation_error, param.saturation);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_core_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_core_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_core_cfg_set" OPTIC_CRLF
		"Short Form: dcdcccs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t v_min" OPTIC_CRLF
		"- uint16_t v_max" OPTIC_CRLF
		"- uint8_t v_tolerance_input" OPTIC_CRLF
		"- uint8_t v_tolerance_target" OPTIC_CRLF
		"- uint8_t pmos_on_delay" OPTIC_CRLF
		"- uint8_t nmos_on_delay" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu %bu %bu %bu %bu", &param.v_min, &param.v_max, &param.v_tolerance_input, &param.v_tolerance_target, &param.pmos_on_delay, &param.nmos_on_delay);
	if (ret != 6) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = dcdc_core_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_core_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_core_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_core_cfg_get" OPTIC_CRLF
		"Short Form: dcdcccg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t v_min" OPTIC_CRLF
		"- uint16_t v_max" OPTIC_CRLF
		"- uint8_t v_tolerance_input" OPTIC_CRLF
		"- uint8_t v_tolerance_target" OPTIC_CRLF
		"- uint8_t pmos_on_delay" OPTIC_CRLF
		"- uint8_t nmos_on_delay" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_core_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d v_min=%hu v_max=%hu v_tolerance_input=%u v_tolerance_target=%u pmos_on_delay=%u nmos_on_delay=%u " OPTIC_CRLF, (int)fct_ret, param.v_min, param.v_max, param.v_tolerance_input, param.v_tolerance_target, param.pmos_on_delay, param.nmos_on_delay);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_core_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_core_enable" OPTIC_CRLF
		"Short Form: dcdcce" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_core_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_core_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_core_disable" OPTIC_CRLF
		"Short Form: dcdccd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_core_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_dcdc_core_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dcdc_core_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: dcdc_core_status_get" OPTIC_CRLF
		"Short Form: dcdccsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t voltage" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = dcdc_core_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d enable=%u voltage=%hu " OPTIC_CRLF, (int)fct_ret, param.enable, param.voltage);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ldo_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ldo_enable" OPTIC_CRLF
		"Short Form: ldoe" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = ldo_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ldo_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ldo_disable" OPTIC_CRLF
		"Short Form: ldod" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = ldo_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ldo_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_ldo_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ldo_status_get" OPTIC_CRLF
		"Short Form: ldosg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool enable \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = ldo_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d enable=%u " OPTIC_CRLF, (int)fct_ret, param.enable);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mm_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_cfg_set" OPTIC_CRLF
		"Short Form: mmcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t tscal_ref" OPTIC_CRLF
		"- uint16_t pn_r" OPTIC_CRLF
		"- enum optic_rssi_1490_mode rssi_1490_mode" OPTIC_CRLF
		"- enum optic_iref pn_iref" OPTIC_CRLF
		"   OPTIC_IREF_20UA = 0" "\n"
		"   OPTIC_IREF_100UA = 1" "\n"
		"   OPTIC_IREF_400UA = 2" "\n"
		"- uint16_t rssi_1490_dark_corr" OPTIC_CRLF
		"- uint16_t rssi_1490_shunt_res" OPTIC_CRLF
		"- enum optic_vref rssi_1550_vref" OPTIC_CRLF
		"   OPTIC_VREF_0MV = 0" "\n"
		"   OPTIC_VREF_500MV = 1" "\n"
		"   OPTIC_VREF_1000MV = 2" "\n"
		"   OPTIC_VREF_1500MV = 3" "\n"
		"- enum optic_vref rf_1550_vref" OPTIC_CRLF
		"   OPTIC_VREF_0MV = 0" "\n"
		"   OPTIC_VREF_500MV = 1" "\n"
		"   OPTIC_VREF_1000MV = 2" "\n"
		"   OPTIC_VREF_1500MV = 3" "\n"
		"- uint16_t rssi_1490_scal_ref" OPTIC_CRLF
		"- uint16_t rssi_1550_scal_ref" OPTIC_CRLF
		"- uint16_t rf_1550_scal_ref" OPTIC_CRLF
		"- uint16_t rssi_1490_parabolic_ref" OPTIC_CRLF
		"- uint16_t rssi_1490_dark_ref" OPTIC_CRLF
		"- bool RSSI_autolevel" OPTIC_CRLF
		"- uint16_t RSSI_1490threshold_low" OPTIC_CRLF
		"- uint16_t RSSI_1490threshold_high" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu %u %u %hu %hu %u %u %hu %hu %hu %hu %hu %bu %u %u",
			&param.tscal_ref, &param.pn_r, &param.rssi_1490_mode, &param.pn_iref,
			&param.rssi_1490_dark_corr, &param.rssi_1490_shunt_res, &param.rssi_1550_vref,
			&param.rf_1550_vref, &param.rssi_1490_scal_ref, &param.rssi_1550_scal_ref,
			&param.rf_1550_scal_ref, &param.rssi_1490_parabolic_ref, &param.rssi_1490_dark_ref,
			&param.RSSI_autolevel, &param.RSSI_1490threshold_low, &param.RSSI_1490threshold_high);
	if (ret != 16) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mm_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mm_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_cfg_get" OPTIC_CRLF
		"Short Form: mmcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t tscal_ref" OPTIC_CRLF
		"- uint16_t pn_r" OPTIC_CRLF
		"- enum optic_rssi_1490_mode rssi_1490_mode" OPTIC_CRLF
		"- enum optic_iref pn_iref" OPTIC_CRLF
		"   OPTIC_IREF_20UA = 0" "\n"
		"   OPTIC_IREF_100UA = 1" "\n"
		"   OPTIC_IREF_400UA = 2" "\n"
		"- uint16_t rssi_1490_dark_corr" OPTIC_CRLF
		"- uint16_t rssi_1490_shunt_res" OPTIC_CRLF
		"- enum optic_vref rssi_1550_vref" OPTIC_CRLF
		"   OPTIC_VREF_0MV = 0" "\n"
		"   OPTIC_VREF_500MV = 1" "\n"
		"   OPTIC_VREF_1000MV = 2" "\n"
		"   OPTIC_VREF_1500MV = 3" "\n"
		"- enum optic_vref rf_1550_vref" OPTIC_CRLF
		"   OPTIC_VREF_0MV = 0" "\n"
		"   OPTIC_VREF_500MV = 1" "\n"
		"   OPTIC_VREF_1000MV = 2" "\n"
		"   OPTIC_VREF_1500MV = 3" "\n"
		"- uint16_t rssi_1490_scal_ref" OPTIC_CRLF
		"- uint16_t rssi_1550_scal_ref" OPTIC_CRLF
		"- uint16_t rf_1550_scal_ref" OPTIC_CRLF
		"- uint16_t rssi_1490_parabolic_ref" OPTIC_CRLF
		"- uint16_t rssi_1490_dark_ref" OPTIC_CRLF
		"- bool RSSI_autolevel" OPTIC_CRLF
		"- uint16_t RSSI_1490threshold_low" OPTIC_CRLF
		"- uint16_t RSSI_1490threshold_high" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tscal_ref=%hu pn_r=%hu rssi_1490_mode=%u pn_iref=%u rssi_1490_dark_corr=%hu rssi_1490_shunt_res=%hu rssi_1550_vref=%u rf_1550_vref=%u rssi_1490_scal_ref=%hu rssi_1550_scal_ref=%hu rf_1550_scal_ref=%hu rssi_1490_parabolic_ref=%hu rssi_1490_dark_ref=%hu  RSSI_autolevel=%hhu RSSI_1490threshold_low=%hu RSSI_1490threshold_high=%hu" OPTIC_CRLF, (int)fct_ret, param.tscal_ref, param.pn_r, param.rssi_1490_mode, param.pn_iref, param.rssi_1490_dark_corr, param.rssi_1490_shunt_res, param.rssi_1550_vref, param.rf_1550_vref, param.rssi_1490_scal_ref, param.rssi_1550_scal_ref, param.rf_1550_scal_ref, param.rssi_1490_parabolic_ref, param.rssi_1490_dark_ref, param.RSSI_autolevel, param.RSSI_1490threshold_low, param.RSSI_1490threshold_high);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_die_temperature_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_temperature param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_die_temperature_get" OPTIC_CRLF
		"Short Form: mmdtg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_die_temperature_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d temperature=%hu " OPTIC_CRLF, (int)fct_ret, param.temperature);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_laser_temperature_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_temperature param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_laser_temperature_get" OPTIC_CRLF
		"Short Form: mmltg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_laser_temperature_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d temperature=%hu " OPTIC_CRLF, (int)fct_ret, param.temperature);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_1490_optical_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage_fine param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_1490_optical_voltage_get" OPTIC_CRLF
		"Short Form: mm1490ovg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_fine_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_1490_optical_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_fine_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_fine_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_1490_optical_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_current_fine param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_1490_optical_current_get" OPTIC_CRLF
		"Short Form: mm1490ocg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t current_fine_val" OPTIC_CRLF
		"- bool is_positive \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_1490_optical_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d current_fine_val=%hu is_positive=%u " OPTIC_CRLF, (int)fct_ret, param.current_fine_val, param.is_positive);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_1490_optical_power_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_power param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_1490_optical_power_get" OPTIC_CRLF
		"Short Form: mm1490opg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t power_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_1490_optical_power_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d power_val=%hu " OPTIC_CRLF, (int)fct_ret, param.power_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_1550_optical_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage_fine param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_1550_optical_voltage_get" OPTIC_CRLF
		"Short Form: mm1550ovg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_fine_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_1550_optical_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_fine_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_fine_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mm_1550_electrical_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage_fine param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mm_1550_electrical_voltage_get" OPTIC_CRLF
		"Short Form: mm1550evg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_fine_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mm_1550_electrical_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_fine_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_fine_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mpd_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mpd_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mpd_cfg_set" OPTIC_CRLF
		"Short Form: mpdcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t tia_gain_selector[4]" OPTIC_CRLF
		"- uint8_t cal_current[4]" OPTIC_CRLF
		"- uint16_t scalefactor_mod[3]" OPTIC_CRLF
		"- int32_t dcal_ref_p0[3]" OPTIC_CRLF
		"- int32_t dcal_ref_p1[3]" OPTIC_CRLF
		"- int32_t dref_p0[3]" OPTIC_CRLF
		"- int32_t dref_p1[3]" OPTIC_CRLF
		"- uint16_t ratio_coarse_fine" OPTIC_CRLF
		"- enum optic_activation powersave" OPTIC_CRLF
		"- uint8_t cid_size_p0" OPTIC_CRLF
		"- uint8_t cid_size_p1" OPTIC_CRLF
		"- bool cid_match_all_p0 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool cid_match_all_p1 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t cid_mask_p0" OPTIC_CRLF
		"- uint16_t cid_mask_p1" OPTIC_CRLF
		"- bool rogue_interburst \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool rogue_intraburst \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu[4] %bu[4] %hu[3] %d[3] %d[3] %d[3] %d[3] %hu %u %bu %bu %bu %bu %hu %hu %bu %bu", &param.tia_gain_selector[0], &param.cal_current[0], &param.scalefactor_mod[0], &param.dcal_ref_p0[0], &param.dcal_ref_p1[0], &param.dref_p0[0], &param.dref_p1[0], &param.ratio_coarse_fine, &param.powersave, &param.cid_size_p0, &param.cid_size_p1, &param.cid_match_all_p0, &param.cid_match_all_p1, &param.cid_mask_p0, &param.cid_mask_p1, &param.rogue_interburst, &param.rogue_intraburst);
	if (ret != 33) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mpd_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mpd_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mpd_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mpd_cfg_get" OPTIC_CRLF
		"Short Form: mpdcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t tia_gain_selector[4]" OPTIC_CRLF
		"- uint8_t cal_current[4]" OPTIC_CRLF
		"- uint16_t scalefactor_mod[3]" OPTIC_CRLF
		"- int32_t dcal_ref_p0[3]" OPTIC_CRLF
		"- int32_t dcal_ref_p1[3]" OPTIC_CRLF
		"- int32_t dref_p0[3]" OPTIC_CRLF
		"- int32_t dref_p1[3]" OPTIC_CRLF
		"- uint16_t ratio_coarse_fine" OPTIC_CRLF
		"- enum optic_activation powersave" OPTIC_CRLF
		"- uint8_t cid_size_p0" OPTIC_CRLF
		"- uint8_t cid_size_p1" OPTIC_CRLF
		"- bool cid_match_all_p0 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool cid_match_all_p1 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t cid_mask_p0" OPTIC_CRLF
		"- uint16_t cid_mask_p1" OPTIC_CRLF
		"- bool rogue_interburst \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool rogue_intraburst \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mpd_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tia_gain_selector=\"%u %u %u %u\" cal_current=\"%u %u %u %u\" scalefactor_mod=\"%hu %hu %hu\" dcal_ref_p0=\"%d %d %d\" dcal_ref_p1=\"%d %d %d\" dref_p0=\"%d %d %d\" dref_p1=\"%d %d %d\" ratio_coarse_fine=%hu powersave=%u cid_size_p0=%u cid_size_p1=%u cid_match_all_p0=%u cid_match_all_p1=%u cid_mask_p0=%hu cid_mask_p1=%hu rogue_interburst=%u rogue_intraburst=%u " OPTIC_CRLF, (int)fct_ret, param.tia_gain_selector[0], param.tia_gain_selector[1], param.tia_gain_selector[2], param.tia_gain_selector[3], param.cal_current[0], param.cal_current[1], param.cal_current[2], param.cal_current[3], param.scalefactor_mod[0], param.scalefactor_mod[1], param.scalefactor_mod[2], param.dcal_ref_p0[0], param.dcal_ref_p0[1], param.dcal_ref_p0[2], param.dcal_ref_p1[0], param.dcal_ref_p1[1], param.dcal_ref_p1[2], param.dref_p0[0], param.dref_p0[1], param.dref_p0[2], param.dref_p1[0], param.dref_p1[1], param.dref_p1[2], param.ratio_coarse_fine, param.powersave, param.cid_size_p0, param.cid_size_p1, param.cid_match_all_p0, param.cid_match_all_p1, param.cid_mask_p0, param.cid_mask_p1, param.rogue_interburst, param.rogue_intraburst);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mpd_trace_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mpd_trace param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mpd_trace_get" OPTIC_CRLF
		"Short Form: mpdtg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t trace_pattern_p0" OPTIC_CRLF
		"- uint16_t trace_pattern_p1" OPTIC_CRLF
		"- uint16_t correlator_trace_p0" OPTIC_CRLF
		"- uint16_t correlator_trace_p1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = mpd_trace_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d trace_pattern_p0=%hu trace_pattern_p1=%hu correlator_trace_p0=%hu correlator_trace_p1=%hu " OPTIC_CRLF, (int)fct_ret, param.trace_pattern_p0, param.trace_pattern_p1, param.correlator_trace_p0, param.correlator_trace_p1);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_enable" OPTIC_CRLF
		"Short Form: berte" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bert_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_disable" OPTIC_CRLF
		"Short Form: bertd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bert_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_synchronize(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_synchronize" OPTIC_CRLF
		"Short Form: berts" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bert_synchronize(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bert_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_status_get" OPTIC_CRLF
		"Short Form: bertsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool bert_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint32_t word_cnt" OPTIC_CRLF
		"- uint32_t error_cnt" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bert_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bert_enable=%u word_cnt=%u error_cnt=%u " OPTIC_CRLF, (int)fct_ret, param.bert_enable, param.word_cnt, param.error_cnt);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_mode_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bert_mode param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_mode_set" OPTIC_CRLF
		"Short Form: bertms" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_bert_modi mode" OPTIC_CRLF
		"   OPTIC_BERT_CONST_ZERO = 0" "\n"
		"   OPTIC_BERT_CONST_ONE = 1" "\n"
		"   OPTIC_BERT_CLOCK = 3" "\n"
		"   OPTIC_BERT_PRBS7 = 7" "\n"
		"   OPTIC_BERT_PRBS11 = 11" "\n"
		"   OPTIC_BERT_PRBS15 = 15" "\n"
		"   OPTIC_BERT_PRBS18 = 18" "\n"
		"   OPTIC_BERT_PRBS21 = 21" "\n"
		"   OPTIC_BERT_PRBS23 = 23" "\n"
		"   OPTIC_BERT_PRBS31 = 31" "\n"
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.mode);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = bert_mode_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bert_counter_reset(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bert_counter_reset" OPTIC_CRLF
		"Short Form: bertcr" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bert_counter_reset(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_omu_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_cfg_set" OPTIC_CRLF
		"Short Form: omucs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- bool signal_detect_avail \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint8_t signal_detect_port" OPTIC_CRLF
		"- uint8_t threshold_lol_set" OPTIC_CRLF
		"- uint8_t threshold_lol_clear" OPTIC_CRLF
		"- bool laser_enable_single_ended \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %bu %bu %bu %bu", &param.signal_detect_avail, &param.signal_detect_port, &param.threshold_lol_set, &param.threshold_lol_clear, &param.laser_enable_single_ended);
	if (ret != 5) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = omu_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_omu_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_cfg_get" OPTIC_CRLF
		"Short Form: omucg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool signal_detect_avail \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint8_t signal_detect_port" OPTIC_CRLF
		"- uint8_t threshold_lol_set" OPTIC_CRLF
		"- uint8_t threshold_lol_clear" OPTIC_CRLF
		"- bool laser_enable_single_ended \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d signal_detect_avail=%u signal_detect_port=%u threshold_lol_set=%u threshold_lol_clear=%u laser_enable_single_ended=%u " OPTIC_CRLF, (int)fct_ret, param.signal_detect_avail, param.signal_detect_port, param.threshold_lol_set, param.threshold_lol_clear, param.laser_enable_single_ended);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_rx_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_rx_enable" OPTIC_CRLF
		"Short Form: omure" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_rx_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_rx_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_rx_disable" OPTIC_CRLF
		"Short Form: omurd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_rx_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_tx_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_tx_enable" OPTIC_CRLF
		"Short Form: omute" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_tx_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_tx_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_tx_disable" OPTIC_CRLF
		"Short Form: omutd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_tx_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_rx_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_omu_rx_status_get param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_rx_status_get" OPTIC_CRLF
		"Short Form: omursg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool rx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_signal \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_lock \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_rx_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d rx_enable=%u loss_of_signal=%u loss_of_lock=%u " OPTIC_CRLF, (int)fct_ret, param.rx_enable, param.loss_of_signal, param.loss_of_lock);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_omu_tx_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_omu_tx_status_get param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: omu_tx_status_get" OPTIC_CRLF
		"Short Form: omutsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool tx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = omu_tx_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tx_enable=%u " OPTIC_CRLF, (int)fct_ret, param.tx_enable);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_rx_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_rx_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_rx_cfg_set" OPTIC_CRLF
		"Short Form: bosarcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- bool dead_zone_elimination \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint8_t threshold_lol_set" OPTIC_CRLF
		"- uint8_t threshold_lol_clear" OPTIC_CRLF
		"- uint16_t threshold_los" OPTIC_CRLF
		"- uint16_t threshold_rx_overload" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %bu %bu %hu %hu", &param.dead_zone_elimination, &param.threshold_lol_set, &param.threshold_lol_clear, &param.threshold_los, &param.threshold_rx_overload);
	if (ret != 5) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = bosa_rx_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_rx_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_rx_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_rx_cfg_get" OPTIC_CRLF
		"Short Form: bosarcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool dead_zone_elimination \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint8_t threshold_lol_set" OPTIC_CRLF
		"- uint8_t threshold_lol_clear" OPTIC_CRLF
		"- uint16_t threshold_los" OPTIC_CRLF
		"- uint16_t threshold_rx_overload" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_rx_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d dead_zone_elimination=%u threshold_lol_set=%u threshold_lol_clear=%u threshold_los=%hu threshold_rx_overload=%hu " OPTIC_CRLF, (int)fct_ret, param.dead_zone_elimination, param.threshold_lol_set, param.threshold_lol_clear, param.threshold_los, param.threshold_rx_overload);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_tx_cfg_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_tx_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_tx_cfg_set" OPTIC_CRLF
		"Short Form: bosatcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_bosa_loop_mode loop_mode" OPTIC_CRLF
		"- uint8_t intcoeff_init[2]" OPTIC_CRLF
		"- uint8_t updatethreshold[2]" OPTIC_CRLF
		"- uint8_t learnthreshold[2]" OPTIC_CRLF
		"- uint8_t stablethreshold[2]" OPTIC_CRLF
		"- uint8_t resetthreshold[2]" OPTIC_CRLF
		"- uint32_t pi_control" OPTIC_CRLF
		"- int16_t p0[3]" OPTIC_CRLF
		"- int16_t p1[3]" OPTIC_CRLF
		"- int16_t pth" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %bu[2] %bu[2] %bu[2] %bu[2] %bu[2] %u %hd[3] %hd[3] %hd", &param.loop_mode, &param.intcoeff_init[0], &param.updatethreshold[0], &param.learnthreshold[0], &param.stablethreshold[0], &param.resetthreshold[0], &param.pi_control, &param.p0[0], &param.p1[0], &param.pth);
	if (ret != 19) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = bosa_tx_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_tx_cfg_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_tx_config param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_tx_cfg_get" OPTIC_CRLF
		"Short Form: bosatcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- enum optic_bosa_loop_mode loop_mode" OPTIC_CRLF
		"- uint8_t intcoeff_init[2]" OPTIC_CRLF
		"- uint8_t updatethreshold[2]" OPTIC_CRLF
		"- uint8_t learnthreshold[2]" OPTIC_CRLF
		"- uint8_t stablethreshold[2]" OPTIC_CRLF
		"- uint8_t resetthreshold[2]" OPTIC_CRLF
		"- uint32_t pi_control" OPTIC_CRLF
		"- int16_t p0[3]" OPTIC_CRLF
		"- int16_t p1[3]" OPTIC_CRLF
		"- int16_t pth" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_tx_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d loop_mode=%u cint_init=\"%u %u\" updatethreshold=\"%u %u\" learnthreshold=\"%u %u\" stablethreshold=\"%u %u\" resetthreshold=\"%u %u\" pi_control=%u p0=\"%hu %hu %hu\" p1=\"%hu %hu %hu\" pth=%hu " OPTIC_CRLF, (int)fct_ret, param.loop_mode, param.intcoeff_init[0], param.intcoeff_init[1], param.updatethreshold[0], param.updatethreshold[1], param.learnthreshold[0], param.learnthreshold[1], param.stablethreshold[0], param.stablethreshold[1], param.resetthreshold[0], param.resetthreshold[1], param.pi_control, param.p0[0], param.p0[1], param.p0[2], param.p1[0], param.p1[1], param.p1[2], param.pth);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_rx_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_rx_enable" OPTIC_CRLF
		"Short Form: bosare" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_rx_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_rx_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_rx_disable" OPTIC_CRLF
		"Short Form: bosard" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_rx_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_tx_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_tx_enable" OPTIC_CRLF
		"Short Form: bosate" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_tx_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_tx_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_tx_disable" OPTIC_CRLF
		"Short Form: bosatd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_tx_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_powerlevel_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_powerlevel param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_powerlevel_set" OPTIC_CRLF
		"Short Form: bosaps" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.powerlevel);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = bosa_powerlevel_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_powerlevel_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_powerlevel param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_powerlevel_get" OPTIC_CRLF
		"Short Form: bosapg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_powerlevel_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d powerlevel=%u " OPTIC_CRLF, (int)fct_ret, param.powerlevel);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_loopmode_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_loopmode param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_loopmode_set" OPTIC_CRLF
		"Short Form: bosals" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_bosa_loop_mode loop_mode" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.loop_mode);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = bosa_loopmode_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_loopmode_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_loopmode param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_loopmode_get" OPTIC_CRLF
		"Short Form: bosalg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- enum optic_bosa_loop_mode loop_mode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_loopmode_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d loop_mode=%u " OPTIC_CRLF, (int)fct_ret, param.loop_mode);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_rx_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_rx_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_rx_status_get" OPTIC_CRLF
		"Short Form: bosarsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool rx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t meas_power_1490_rssi" OPTIC_CRLF
		"- uint16_t meas_voltage_1490_rssi" OPTIC_CRLF
		"- uint16_t meas_current_1490_rssi" OPTIC_CRLF
		"- bool meas_current_1490_rssi_is_positive \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t meas_voltage_1550_rf" OPTIC_CRLF
		"- uint16_t meas_voltage_1550_rssi" OPTIC_CRLF
		"- bool loss_of_signal \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_lock \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_rx_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d rx_enable=%u meas_power_1490_rssi=%hu meas_voltage_1490_rssi=%hu meas_current_1490_rssi=%hu meas_current_1490_rssi_is_positive=%u meas_voltage_1550_rf=%hu meas_voltage_1550_rssi=%hu loss_of_signal=%u loss_of_lock=%u " OPTIC_CRLF, (int)fct_ret, param.rx_enable, param.meas_power_1490_rssi, param.meas_voltage_1490_rssi, param.meas_current_1490_rssi, param.meas_current_1490_rssi_is_positive, param.meas_voltage_1550_rf, param.meas_voltage_1550_rssi, param.loss_of_signal, param.loss_of_lock);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_tx_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_tx_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_tx_status_get" OPTIC_CRLF
		"Short Form: bosatsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool tx_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		"- uint16_t bias_current" OPTIC_CRLF
		"- uint16_t modulation_current" OPTIC_CRLF
		"- uint16_t laser_threshold" OPTIC_CRLF
		"- uint16_t slope_efficiency" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_tx_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tx_enable=%u bias_current=%hu modulation_current=%hu laser_threshold=%hu slope_efficiency=%hu " OPTIC_CRLF, (int)fct_ret, param.tx_enable, param.bias_current, param.modulation_current, param.laser_threshold, param.slope_efficiency);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_alarm_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bosa_alarm param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_alarm_status_get" OPTIC_CRLF
		"Short Form: bosaasg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool loss_of_signal \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool loss_of_lock \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool rx_overload \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool bias_overload \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool modulation_overload \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool laser_overload \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool rogue_p0 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool rogue_p1 \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_alarm_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d loss_of_signal=%u loss_of_lock=%u rx_overload=%u bias_overload=%u modulation_overload=%u laser_overload=%u rogue_p0=%u rogue_p1=%u " OPTIC_CRLF, (int)fct_ret, param.loss_of_signal, param.loss_of_lock, param.rx_overload, param.bias_overload, param.modulation_overload, param.laser_overload, param.rogue_p0, param.rogue_p1);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_alarm_status_clear(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_alarm_status_clear" OPTIC_CRLF
		"Short Form: bosaasc" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_alarm_status_clear(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_int_coeff_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_int_coeff param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_int_coeff_get" OPTIC_CRLF
		"Short Form: bosaicg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t intcoeff[2]" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_int_coeff_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d intcoeff=\"%u %u\" " OPTIC_CRLF, (int)fct_ret, param.intcoeff[0], param.intcoeff[1]);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_bosa_stable_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_stable param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: bosa_stable_get" OPTIC_CRLF
		"Short Form: bosasg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool stable[2] \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = bosa_stable_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d stable=\"%u %u\" " OPTIC_CRLF, (int)fct_ret, param.stable[0], param.stable[1]);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_debug_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_debug_enable" OPTIC_CRLF
		"Short Form: calde" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_debug_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_debug_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_debug_disable" OPTIC_CRLF
		"Short Form: caldd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_debug_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mm_enable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mm_enable" OPTIC_CRLF
		"Short Form: calme" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mm_enable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mm_disable(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mm_disable" OPTIC_CRLF
		"Short Form: calmd" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mm_disable(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_debug_status_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_debug_status param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_debug_status_get" OPTIC_CRLF
		"Short Form: caldsg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- bool debug_enable \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_debug_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d debug_enable=%u " OPTIC_CRLF, (int)fct_ret, param.debug_enable);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_laser_age_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_timestamp param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_laser_age_get" OPTIC_CRLF
		"Short Form: callag" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint32_t seconds" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_laser_age_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d seconds=%u " OPTIC_CRLF, (int)fct_ret, param.seconds);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_ibiasimod_table_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_ibiasimod_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_ibiasimod_table_set" OPTIC_CRLF
		"Short Form: calits" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		"- uint16_t ibias" OPTIC_CRLF
		"- uint16_t imod" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %u %hu %hu", &param.temperature, &param.powerlevel, &param.ibias, &param.imod);
	if (ret != 4) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_ibiasimod_table_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_ibiasimod_table_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_ibiasimod_get_in param_in;
	struct optic_ibiasimod_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_ibiasimod_table_get" OPTIC_CRLF
		"Short Form: calitg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t ibias" OPTIC_CRLF
		"- uint16_t imod" OPTIC_CRLF
		"- enum optic_tableval_quality quality" OPTIC_CRLF
		"   OPTIC_TABLEQUAL_UNKNOWN = 0" "\n"
		"   OPTIC_TABLEQUAL_INITIAL = 1" "\n"
		"   OPTIC_TABLEQUAL_FIXSET = 2" "\n"
		"   OPTIC_TABLEQUAL_BORDER = 3" "\n"
		"   OPTIC_TABLEQUAL_EXTRAP = 4" "\n"
		"   OPTIC_TABLEQUAL_INTERP = 5" "\n"
		"   OPTIC_TABLEQUAL_CALC = 6" "\n"
		"   OPTIC_TABLEQUAL_STORE = 7" "\n"
		"   OPTIC_TABLEQUAL_MEAS = 8" "\n"
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %u", &param_in.temperature, &param_in.powerlevel);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_ibiasimod_table_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d ibias=%hu imod=%hu quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.ibias, param_out.imod, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_laserref_table_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_laserref_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_laserref_table_set" OPTIC_CRLF
		"Short Form: callts" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- uint16_t ith" OPTIC_CRLF
		"- uint16_t se" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu %hu", &param.temperature, &param.ith, &param.se);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_laserref_table_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_laserref_table_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_laserref_get_in param_in;
	struct optic_laserref_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_laserref_table_get" OPTIC_CRLF
		"Short Form: calltg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t ith" OPTIC_CRLF
		"- uint16_t se" OPTIC_CRLF
		"- uint32_t age" OPTIC_CRLF
		"- enum optic_tableval_quality quality" OPTIC_CRLF
		"   OPTIC_TABLEQUAL_UNKNOWN = 0" "\n"
		"   OPTIC_TABLEQUAL_INITIAL = 1" "\n"
		"   OPTIC_TABLEQUAL_FIXSET = 2" "\n"
		"   OPTIC_TABLEQUAL_BORDER = 3" "\n"
		"   OPTIC_TABLEQUAL_EXTRAP = 4" "\n"
		"   OPTIC_TABLEQUAL_INTERP = 5" "\n"
		"   OPTIC_TABLEQUAL_CALC = 6" "\n"
		"   OPTIC_TABLEQUAL_STORE = 7" "\n"
		"   OPTIC_TABLEQUAL_MEAS = 8" "\n"
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param_in.temperature);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_laserref_table_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d ith=%hu se=%hu age=%u quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.ith, param_out.se, param_out.age, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_vapd_table_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_vapd_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_vapd_table_set" OPTIC_CRLF
		"Short Form: calvts" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- uint16_t vref" OPTIC_CRLF
		"- uint8_t sat" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu %bu", &param.temperature, &param.vref, &param.sat);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_vapd_table_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_vapd_table_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_vapd_get_in param_in;
	struct optic_vapd_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_vapd_table_get" OPTIC_CRLF
		"Short Form: calvtg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t vref" OPTIC_CRLF
		"- uint8_t sat" OPTIC_CRLF
		"- enum optic_tableval_quality quality" OPTIC_CRLF
		"   OPTIC_TABLEQUAL_UNKNOWN = 0" "\n"
		"   OPTIC_TABLEQUAL_INITIAL = 1" "\n"
		"   OPTIC_TABLEQUAL_FIXSET = 2" "\n"
		"   OPTIC_TABLEQUAL_BORDER = 3" "\n"
		"   OPTIC_TABLEQUAL_EXTRAP = 4" "\n"
		"   OPTIC_TABLEQUAL_INTERP = 5" "\n"
		"   OPTIC_TABLEQUAL_CALC = 6" "\n"
		"   OPTIC_TABLEQUAL_STORE = 7" "\n"
		"   OPTIC_TABLEQUAL_MEAS = 8" "\n"
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param_in.temperature);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_vapd_table_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d vref=%hu sat=%u quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.vref, param_out.sat, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_corr_table_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_corr_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_corr_table_set" OPTIC_CRLF
		"Short Form: calcts" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_cfactor type" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- uint16_t corr_factor" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %hu %hu", &param.type, &param.temperature, &param.corr_factor);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_corr_table_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_corr_table_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_corr_get_in param_in;
	struct optic_corr_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_corr_table_get" OPTIC_CRLF
		"Short Form: calctg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_cfactor type" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t corr_factor" OPTIC_CRLF
		"- enum optic_tableval_quality quality" OPTIC_CRLF
		"   OPTIC_TABLEQUAL_UNKNOWN = 0" "\n"
		"   OPTIC_TABLEQUAL_INITIAL = 1" "\n"
		"   OPTIC_TABLEQUAL_FIXSET = 2" "\n"
		"   OPTIC_TABLEQUAL_BORDER = 3" "\n"
		"   OPTIC_TABLEQUAL_EXTRAP = 4" "\n"
		"   OPTIC_TABLEQUAL_INTERP = 5" "\n"
		"   OPTIC_TABLEQUAL_CALC = 6" "\n"
		"   OPTIC_TABLEQUAL_STORE = 7" "\n"
		"   OPTIC_TABLEQUAL_MEAS = 8" "\n"
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %hu", &param_in.type, &param_in.temperature);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_corr_table_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d corr_factor=%hu quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.corr_factor, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_tcorrext_table_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tcorrext_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_tcorrext_table_set" OPTIC_CRLF
		"Short Form: caltts" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		"- uint16_t temp_corr" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu", &param.temperature, &param.temp_corr);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_tcorrext_table_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_tcorrext_table_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tcorrext_get_in param_in;
	struct optic_tcorrext_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_tcorrext_table_get" OPTIC_CRLF
		"Short Form: calttg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t temperature" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t temp_corr" OPTIC_CRLF
		"- enum optic_tableval_quality quality" OPTIC_CRLF
		"   OPTIC_TABLEQUAL_UNKNOWN = 0" "\n"
		"   OPTIC_TABLEQUAL_INITIAL = 1" "\n"
		"   OPTIC_TABLEQUAL_FIXSET = 2" "\n"
		"   OPTIC_TABLEQUAL_BORDER = 3" "\n"
		"   OPTIC_TABLEQUAL_EXTRAP = 4" "\n"
		"   OPTIC_TABLEQUAL_INTERP = 5" "\n"
		"   OPTIC_TABLEQUAL_CALC = 6" "\n"
		"   OPTIC_TABLEQUAL_STORE = 7" "\n"
		"   OPTIC_TABLEQUAL_MEAS = 8" "\n"
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param_in.temperature);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_tcorrext_table_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d temp_corr=%hu quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.temp_corr, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_init_bias_current_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bias param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_init_bias_current_set" OPTIC_CRLF
		"Short Form: calibcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t bias_current" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.bias_current);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_init_bias_current_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_init_bias_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bias param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_init_bias_current_get" OPTIC_CRLF
		"Short Form: calibcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t bias_current" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_init_bias_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bias_current=%hu " OPTIC_CRLF, (int)fct_ret, param.bias_current);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_init_mod_current_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mod param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_init_mod_current_set" OPTIC_CRLF
		"Short Form: calimcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t modulation_current" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.modulation_current);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_init_mod_current_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_init_mod_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mod param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_init_mod_current_get" OPTIC_CRLF
		"Short Form: calimcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t modulation_current" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_init_mod_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d modulation_current=%hu " OPTIC_CRLF, (int)fct_ret, param.modulation_current);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_actual_bias_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_bias param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_actual_bias_current_get" OPTIC_CRLF
		"Short Form: calabcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t bias_current" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_actual_bias_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bias_current=%hu " OPTIC_CRLF, (int)fct_ret, param.bias_current);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_actual_mod_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_mod param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_actual_mod_current_get" OPTIC_CRLF
		"Short Form: calamcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t modulation_current" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_actual_mod_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d modulation_current=%hu " OPTIC_CRLF, (int)fct_ret, param.modulation_current);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_gain_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_gain_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_gain_set" OPTIC_CRLF
		"Short Form: calmgs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		"- uint8_t tia_gain_selector" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %bu", &param.gainbank, &param.tia_gain_selector);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_gain_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_gain_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_gain_get_in param_in;
	struct optic_gain_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_gain_get" OPTIC_CRLF
		"Short Form: calmgg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t tia_gain_selector" OPTIC_CRLF
		"- enum optic_quality quality" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param_in.gainbank);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_gain_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d tia_gain_selector=%u quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.tia_gain_selector, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_gain_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_gain param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_gain_set" OPTIC_CRLF
		"Short Form: calmdgs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t tia_gain_selector" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu", &param.tia_gain_selector);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_dbg_gain_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_gain_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_gain param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_gain_get" OPTIC_CRLF
		"Short Form: calmdgg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t tia_gain_selector" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_dbg_gain_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tia_gain_selector=%u " OPTIC_CRLF, (int)fct_ret, param.tia_gain_selector);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_cal_current_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_cal_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_cal_current_set" OPTIC_CRLF
		"Short Form: calmccs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		"- uint8_t cal_current" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %bu", &param.gainbank, &param.cal_current);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_cal_current_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_cal_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_cal_get_in param_in;
	struct optic_cal_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_cal_current_get" OPTIC_CRLF
		"Short Form: calmccg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t cal_current" OPTIC_CRLF
		"- enum optic_quality quality" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param_in.gainbank);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_cal_current_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d cal_current=%u quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.cal_current, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_cal_current_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_cal param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_cal_current_set" OPTIC_CRLF
		"Short Form: calmdccs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t cal_current" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu", &param.cal_current);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_dbg_cal_current_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_cal_current_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_cal param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_cal_current_get" OPTIC_CRLF
		"Short Form: calmdccg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t cal_current" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_dbg_cal_current_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d cal_current=%u " OPTIC_CRLF, (int)fct_ret, param.cal_current);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_ref_codeword_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_refcw_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_ref_codeword_set" OPTIC_CRLF
		"Short Form: calmrcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		"- int32_t dcal_ref_p0" OPTIC_CRLF
		"- int32_t dcal_ref_p1" OPTIC_CRLF
		"- int32_t dref_p0" OPTIC_CRLF
		"- int32_t dref_p1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %d %d %d %d", &param.powerlevel, &param.dcal_ref_p0, &param.dcal_ref_p1, &param.dref_p0, &param.dref_p1);
	if (ret != 5) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_ref_codeword_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_ref_codeword_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_refcw_get_in param_in;
	struct optic_refcw_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_ref_codeword_get" OPTIC_CRLF
		"Short Form: calmrcg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_powerlevel powerlevel" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- int32_t dcal_ref_p0" OPTIC_CRLF
		"- int32_t dcal_ref_p1" OPTIC_CRLF
		"- int32_t dref_p0" OPTIC_CRLF
		"- int32_t dref_p1" OPTIC_CRLF
		"- enum optic_quality quality" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param_in.powerlevel);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_ref_codeword_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d dcal_ref_p0=%d dcal_ref_p1=%d dref_p0=%d dref_p1=%d quality=%u " OPTIC_CRLF, (int)fct_ret, param_out.dcal_ref_p0, param_out.dcal_ref_p1, param_out.dref_p0, param_out.dref_p1, param_out.quality);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_ref_codeword_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_refcw param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_ref_codeword_set" OPTIC_CRLF
		"Short Form: calmdrcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- int32_t dcal_ref_p0" OPTIC_CRLF
		"- int32_t dcal_ref_p1" OPTIC_CRLF
		"- int32_t dref_p0" OPTIC_CRLF
		"- int32_t dref_p1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%d %d %d %d", &param.dcal_ref_p0, &param.dcal_ref_p1, &param.dref_p0, &param.dref_p1);
	if (ret != 4) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_dbg_ref_codeword_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_ref_codeword_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_refcw param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_ref_codeword_get" OPTIC_CRLF
		"Short Form: calmdrcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- int32_t dcal_ref_p0" OPTIC_CRLF
		"- int32_t dcal_ref_p1" OPTIC_CRLF
		"- int32_t dref_p0" OPTIC_CRLF
		"- int32_t dref_p1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_dbg_ref_codeword_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d dcal_ref_p0=%d dcal_ref_p1=%d dref_p0=%d dref_p1=%d " OPTIC_CRLF, (int)fct_ret, param.dcal_ref_p0, param.dcal_ref_p1, param.dref_p0, param.dref_p1);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_tia_offset_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tia_offset_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_tia_offset_set" OPTIC_CRLF
		"Short Form: calmtos" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		"- int16_t tia_offset_coarse" OPTIC_CRLF
		"- int16_t tia_offset_fine" OPTIC_CRLF
		"- int16_t tia_offset_p1_coarse" OPTIC_CRLF
		"- int16_t tia_offset_p1_fine" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u %hd %hd %hd %hd", &param.gainbank, &param.tia_offset_coarse, &param.tia_offset_fine, &param.tia_offset_p1_coarse, &param.tia_offset_p1_fine);
	if (ret != 5) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_tia_offset_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_tia_offset_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tia_offset_get_in param_in;
	struct optic_tia_offset_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_tia_offset_get" OPTIC_CRLF
		"Short Form: calmtog" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_gainbank gainbank" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- int16_t tia_offset_coarse" OPTIC_CRLF
		"- int16_t tia_offset_fine" OPTIC_CRLF
		"- int16_t tia_offset_p1_coarse" OPTIC_CRLF
		"- int16_t tia_offset_p1_fine" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param_in.gainbank);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_tia_offset_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d tia_offset_coarse=%hd tia_offset_fine=%hd tia_offset_p1_coarse=%hd tia_offset_p1_fine=%hd " OPTIC_CRLF, (int)fct_ret, param_out.tia_offset_coarse, param_out.tia_offset_fine, param_out.tia_offset_p1_coarse, param_out.tia_offset_p1_fine);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_tia_offset_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_tia_offset param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_tia_offset_set" OPTIC_CRLF
		"Short Form: calmdtos" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- int16_t tia_offset_coarse" OPTIC_CRLF
		"- int16_t tia_offset_fine" OPTIC_CRLF
		"- int16_t tia_offset_p1_coarse" OPTIC_CRLF
		"- int16_t tia_offset_p1_fine" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hd %hd %hd %hd", &param.tia_offset_coarse, &param.tia_offset_fine, &param.tia_offset_p1_coarse, &param.tia_offset_p1_fine);
	if (ret != 4) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_dbg_tia_offset_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_dbg_tia_offset_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_dbg_tia_offset param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_dbg_tia_offset_get" OPTIC_CRLF
		"Short Form: calmdtog" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- int16_t tia_offset_coarse" OPTIC_CRLF
		"- int16_t tia_offset_fine" OPTIC_CRLF
		"- int16_t tia_offset_p1_coarse" OPTIC_CRLF
		"- int16_t tia_offset_p1_fine" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_dbg_tia_offset_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tia_offset_coarse=%hd tia_offset_fine=%hd tia_offset_p1_coarse=%hd tia_offset_p1_fine=%hd " OPTIC_CRLF, (int)fct_ret, param.tia_offset_coarse, param.tia_offset_fine, param.tia_offset_p1_coarse, param.tia_offset_p1_fine);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_tia_offset_find(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_tia_offset_find" OPTIC_CRLF
		"Short Form: calmtof" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_tia_offset_find(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_level_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_level_set param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_level_set" OPTIC_CRLF
		"Short Form: calmls" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t level_select" OPTIC_CRLF
		"- int32_t level_value" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %d", &param.level_select, &param.level_value);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_level_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_level_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_level_get_in param_in;
	struct optic_level_get_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_level_get" OPTIC_CRLF
		"Short Form: calmlg" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t level_select" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t gain_correction" OPTIC_CRLF
		"- int32_t level_value" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu", &param_in.level_select);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_level_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d gain_correction=%hu level_value=%d " OPTIC_CRLF, (int)fct_ret, param_out.gain_correction, param_out.level_value);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_level_find(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_level_find_in param_in;
	struct optic_level_find_out param_out;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_level_find" OPTIC_CRLF
		"Short Form: calmlf" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- bool offset_cancellation \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool calibrate_p0 \n   false = 0\n   true = 1" OPTIC_CRLF
		"- bool calibrate_p1 \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- int16_t level_p0" OPTIC_CRLF
		"- int16_t level_p1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %bu %bu", &param_in.offset_cancellation, &param_in.calibrate_p0, &param_in.calibrate_p1);
	if (ret != 3) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_level_find(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d level_p0=%hd level_p1=%hd " OPTIC_CRLF, (int)fct_ret, param_out.level_p0, param_out.level_p1);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_cfratio_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_cfratio param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_cfratio_set" OPTIC_CRLF
		"Short Form: calmcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t ratio_p0" OPTIC_CRLF
		"- uint16_t ratio_p1" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu %hu", &param.ratio_p0, &param.ratio_p1);
	if (ret != 2) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_cfratio_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_cfratio_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_cfratio param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_cfratio_get" OPTIC_CRLF
		"Short Form: calmcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t ratio_p0" OPTIC_CRLF
		"- uint16_t ratio_p1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_cfratio_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d ratio_p0=%hu ratio_p1=%hu " OPTIC_CRLF, (int)fct_ret, param.ratio_p0, param.ratio_p1);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_cfratio_find(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_cfratio_find" OPTIC_CRLF
		"Short Form: calmcf" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_cfratio_find(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_powersave_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_powersave param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_powersave_set" OPTIC_CRLF
		"Short Form: calmps" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- enum optic_activation powersave" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%u", &param.powersave);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mpd_powersave_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mpd_powersave_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_powersave param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mpd_powersave_get" OPTIC_CRLF
		"Short Form: calmpg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- enum optic_activation powersave" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mpd_powersave_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d powersave=%u " OPTIC_CRLF, (int)fct_ret, param.powersave);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_fcsi_predriver_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_fcsi_predriver param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_fcsi_predriver_set" OPTIC_CRLF
		"Short Form: calfps" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t dd_loadn" OPTIC_CRLF
		"- uint8_t dd_bias_en" OPTIC_CRLF
		"- uint8_t dd_loadp" OPTIC_CRLF
		"- uint8_t dd_cm_load" OPTIC_CRLF
		"- uint8_t bd_loadn" OPTIC_CRLF
		"- uint8_t bd_bias_en" OPTIC_CRLF
		"- uint8_t bd_loadp" OPTIC_CRLF
		"- uint8_t bd_cm_load" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu %bu %bu %bu %bu %bu %bu %bu", &param.dd_loadn, &param.dd_bias_en, &param.dd_loadp, &param.dd_cm_load, &param.bd_loadn, &param.bd_bias_en, &param.bd_loadp, &param.bd_cm_load);
	if (ret != 8) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_fcsi_predriver_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_fcsi_predriver_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_fcsi_predriver param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_fcsi_predriver_get" OPTIC_CRLF
		"Short Form: calfpg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t dd_loadn" OPTIC_CRLF
		"- uint8_t dd_bias_en" OPTIC_CRLF
		"- uint8_t dd_loadp" OPTIC_CRLF
		"- uint8_t dd_cm_load" OPTIC_CRLF
		"- uint8_t bd_loadn" OPTIC_CRLF
		"- uint8_t bd_bias_en" OPTIC_CRLF
		"- uint8_t bd_loadp" OPTIC_CRLF
		"- uint8_t bd_cm_load" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_fcsi_predriver_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d dd_loadn=%u dd_bias_en=%u dd_loadp=%u dd_cm_load=%u bd_loadn=%u bd_bias_en=%u bd_loadp=%u bd_cm_load=%u " OPTIC_CRLF, (int)fct_ret, param.dd_loadn, param.dd_bias_en, param.dd_loadp, param.dd_cm_load, param.bd_loadn, param.bd_bias_en, param.bd_loadp, param.bd_cm_load);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_apd_voltage_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_apd_voltage_set" OPTIC_CRLF
		"Short Form: caldavs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.voltage_val);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_dcdc_apd_voltage_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_apd_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_apd_voltage_get" OPTIC_CRLF
		"Short Form: caldavg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_dcdc_apd_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_core_voltage_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_core_voltage_set" OPTIC_CRLF
		"Short Form: caldcvs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.voltage_val);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_dcdc_core_voltage_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_core_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_core_voltage_get" OPTIC_CRLF
		"Short Form: caldcvg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_dcdc_core_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_ddr_voltage_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_ddr_voltage_set" OPTIC_CRLF
		"Short Form: calddvs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.voltage_val);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_dcdc_ddr_voltage_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_dcdc_ddr_voltage_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_voltage param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_dcdc_ddr_voltage_get" OPTIC_CRLF
		"Short Form: calddvg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t voltage_val" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_dcdc_ddr_voltage_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d voltage_val=%hu " OPTIC_CRLF, (int)fct_ret, param.voltage_val);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_laser_delay_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_laserdelay param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_laser_delay_set" OPTIC_CRLF
		"Short Form: callds" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint8_t bitdelay" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%bu", &param.bitdelay);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_laser_delay_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_laser_delay_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_laserdelay param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_laser_delay_get" OPTIC_CRLF
		"Short Form: calldg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t bitdelay" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_laser_delay_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bitdelay=%u " OPTIC_CRLF, (int)fct_ret, param.bitdelay);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mm_dark_corr_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_rssi_1490_dark param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mm_dark_corr_set" OPTIC_CRLF
		"Short Form: calmdcs" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t corr_factor" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.corr_factor);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_mm_dark_corr_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mm_dark_corr_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_rssi_1490_dark param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mm_dark_corr_get" OPTIC_CRLF
		"Short Form: calmdcg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t corr_factor" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mm_dark_corr_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d corr_factor=%hu " OPTIC_CRLF, (int)fct_ret, param.corr_factor);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_mm_dark_corr_find(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_mm_dark_corr_find" OPTIC_CRLF
		"Short Form: calmdcf" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_mm_dark_corr_find(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_fusing_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_fusing param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_fusing_get" OPTIC_CRLF
		"Short Form: calfg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint8_t format" OPTIC_CRLF
		"- uint8_t vcal_mm20" OPTIC_CRLF
		"- uint8_t vcal_mm100" OPTIC_CRLF
		"- uint8_t vcal_mm400" OPTIC_CRLF
		"- uint8_t rcal_mm" OPTIC_CRLF
		"- uint8_t temp_mm" OPTIC_CRLF
		"- uint8_t tbgp" OPTIC_CRLF
		"- uint8_t vbgp" OPTIC_CRLF
		"- uint8_t irefbgp" OPTIC_CRLF
		"- uint8_t gain_dac_drive" OPTIC_CRLF
		"- uint8_t gain_dac_bias" OPTIC_CRLF
		"- uint8_t offset_dcdc_ddr" OPTIC_CRLF
		"- uint8_t gain_dcdc_ddr" OPTIC_CRLF
		"- int8_t offset_dcdc_core" OPTIC_CRLF
		"- uint8_t gain_dcdc_core" OPTIC_CRLF
		"- int8_t offset_dcdc_apd" OPTIC_CRLF
		"- uint8_t gain_dcdc_apd" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_fusing_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d format=%u vcal_mm20=%u vcal_mm100=%u vcal_mm400=%u rcal_mm=%u temp_mm=%u tbgp=%u vbgp=%u irefbgp=%u gain_dac_drive=%u gain_dac_bias=%u offset_dcdc_ddr=%u gain_dcdc_ddr=%u offset_dcdc_core=%d gain_dcdc_core=%u offset_dcdc_apd=%d gain_dcdc_apd=%u " OPTIC_CRLF, (int)fct_ret, param.format, param.vcal_mm20, param.vcal_mm100, param.vcal_mm400, param.rcal_mm, param.temp_mm, param.tbgp, param.vbgp, param.irefbgp, param.gain_dac_drive, param.gain_dac_bias, param.offset_dcdc_ddr, param.gain_dcdc_ddr, param.offset_dcdc_core, param.gain_dcdc_core, param.offset_dcdc_apd, param.gain_dcdc_apd);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_tscalref_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tscalref param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_tscalref_set" OPTIC_CRLF
		"Short Form: calts" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t tscal_ref" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.tscal_ref);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_tscalref_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_tscalref_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_tscalref param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_tscalref_get" OPTIC_CRLF
		"Short Form: caltg" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t tscal_ref" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_tscalref_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tscal_ref=%hu " OPTIC_CRLF, (int)fct_ret, param.tscal_ref);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_current_offset_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_current_fine param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_current_offset_get" OPTIC_CRLF
		"Short Form: calcog" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t current_fine_val" OPTIC_CRLF
		"- bool is_positive \n   false = 0\n   true = 1" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_current_offset_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d current_fine_val=%hu is_positive=%u " OPTIC_CRLF, (int)fct_ret, param.current_fine_val, param.is_positive);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_rx_offset_set(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_rx_offset param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_rx_offset_set" OPTIC_CRLF
		"Short Form: calros" OPTIC_CRLF
		OPTIC_CRLF
		"Input Parameter" OPTIC_CRLF
		"- uint16_t rx_offset" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = optic_cli_sscanf(p_cmd, "%hu", &param.rx_offset);
	if (ret != 1) {
		return optic_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = cal_rx_offset_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_rx_offset_get(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;
	struct optic_rx_offset param;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_rx_offset_get" OPTIC_CRLF
		"Short Form: calrog" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		"- uint16_t rx_offset" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_rx_offset_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d rx_offset=%hu " OPTIC_CRLF, (int)fct_ret, param.rx_offset);
}

/** Handle command

   \param[in] p_dev     OPTIC device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_cal_rx_offset_find(
	struct optic_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum optic_errorcode fct_ret = (enum optic_errorcode) 0;

#ifndef OPTIC_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: cal_rx_offset_find" OPTIC_CRLF
		"Short Form: calrof" OPTIC_CRLF
		OPTIC_CRLF
		"Output Parameter" OPTIC_CRLF
		"- enum optic_errorcode errorcode" OPTIC_CRLF
		OPTIC_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = optic_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = cal_rx_offset_find(p_dev);
	return sprintf(p_out, "errorcode=%d " OPTIC_CRLF, (int)fct_ret);
}

/** Register autogenerated commands */
void optic_cli_autogen_register(
	void)
{
#if defined(INCLUDE_DEBUG_SUPPORT)
optic_cli_command_add("opticds", "optic_debuglevel_set", cli_optic_debuglevel_set);
optic_cli_command_add("opticdg", "optic_debuglevel_get", cli_optic_debuglevel_get);
#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
optic_cli_command_add("opticvg", "optic_version_get", cli_optic_version_get);
optic_cli_command_add("opticrs", "optic_register_set", cli_optic_register_set);
optic_cli_command_add("opticrg", "optic_register_get", cli_optic_register_get);
optic_cli_command_add("opticr", "optic_reset", cli_optic_reset);
optic_cli_command_add(CLI_EMPTY_CMD, "optic_reconfig", cli_optic_reconfig);
optic_cli_command_add("opticms", "optic_mode_set", cli_optic_mode_set);
optic_cli_command_add("goii", "goi_init", cli_goi_init);
optic_cli_command_add("goics", "goi_cfg_set", cli_goi_cfg_set);
optic_cli_command_add("goicg", "goi_cfg_get", cli_goi_cfg_get);
optic_cli_command_add("goircs", "goi_range_cfg_set", cli_goi_range_cfg_set);
optic_cli_command_add("goircg", "goi_range_cfg_get", cli_goi_range_cfg_get);
optic_cli_command_add("goisg", "goi_status_get", cli_goi_status_get);
optic_cli_command_add("goiesg", "goi_ext_status_get", cli_goi_ext_status_get);
optic_cli_command_add("goivcs", "goi_video_cfg_set", cli_goi_video_cfg_set);
optic_cli_command_add("goivcg", "goi_video_cfg_get", cli_goi_video_cfg_get);
optic_cli_command_add("goive", "goi_video_enable", cli_goi_video_enable);
optic_cli_command_add("goivd", "goi_video_disable", cli_goi_video_disable);
optic_cli_command_add("goivsg", "goi_video_status_get", cli_goi_video_status_get);
#if defined(INCLUDE_DEBUG_SUPPORT)
optic_cli_command_add("goimics", "goi_mm_interval_cfg_set", cli_goi_mm_interval_cfg_set);
#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
optic_cli_command_add("fcsics", "fcsi_cfg_set", cli_fcsi_cfg_set);
optic_cli_command_add("fcsicg", "fcsi_cfg_get", cli_fcsi_cfg_get);
optic_cli_command_add("dcdcacs", "dcdc_apd_cfg_set", cli_dcdc_apd_cfg_set);
optic_cli_command_add("dcdcacg", "dcdc_apd_cfg_get", cli_dcdc_apd_cfg_get);
optic_cli_command_add("dcdcae", "dcdc_apd_enable", cli_dcdc_apd_enable);
optic_cli_command_add("dcdcad", "dcdc_apd_disable", cli_dcdc_apd_disable);
optic_cli_command_add("dcdcasg", "dcdc_apd_status_get", cli_dcdc_apd_status_get);
optic_cli_command_add("dcdcccs", "dcdc_core_cfg_set", cli_dcdc_core_cfg_set);
optic_cli_command_add("dcdcccg", "dcdc_core_cfg_get", cli_dcdc_core_cfg_get);
optic_cli_command_add("dcdcce", "dcdc_core_enable", cli_dcdc_core_enable);
optic_cli_command_add("dcdccd", "dcdc_core_disable", cli_dcdc_core_disable);
optic_cli_command_add("dcdccsg", "dcdc_core_status_get", cli_dcdc_core_status_get);
optic_cli_command_add("ldoe", "ldo_enable", cli_ldo_enable);
optic_cli_command_add("ldod", "ldo_disable", cli_ldo_disable);
optic_cli_command_add("ldosg", "ldo_status_get", cli_ldo_status_get);
optic_cli_command_add("mmcs", "mm_cfg_set", cli_mm_cfg_set);
optic_cli_command_add("mmcg", "mm_cfg_get", cli_mm_cfg_get);
optic_cli_command_add("mmdtg", "mm_die_temperature_get", cli_mm_die_temperature_get);
optic_cli_command_add("mmltg", "mm_laser_temperature_get", cli_mm_laser_temperature_get);
optic_cli_command_add("mm1490ovg", "mm_1490_optical_voltage_get", cli_mm_1490_optical_voltage_get);
optic_cli_command_add("mm1490ocg", "mm_1490_optical_current_get", cli_mm_1490_optical_current_get);
optic_cli_command_add("mm1490opg", "mm_1490_optical_power_get", cli_mm_1490_optical_power_get);
optic_cli_command_add("mm1550ovg", "mm_1550_optical_voltage_get", cli_mm_1550_optical_voltage_get);
optic_cli_command_add("mm1550evg", "mm_1550_electrical_voltage_get", cli_mm_1550_electrical_voltage_get);
optic_cli_command_add("mpdcs", "mpd_cfg_set", cli_mpd_cfg_set);
optic_cli_command_add("mpdcg", "mpd_cfg_get", cli_mpd_cfg_get);
optic_cli_command_add("mpdtg", "mpd_trace_get", cli_mpd_trace_get);
optic_cli_command_add("berte", "bert_enable", cli_bert_enable);
optic_cli_command_add("bertd", "bert_disable", cli_bert_disable);
optic_cli_command_add("berts", "bert_synchronize", cli_bert_synchronize);
optic_cli_command_add("bertsg", "bert_status_get", cli_bert_status_get);
optic_cli_command_add("bertms", "bert_mode_set", cli_bert_mode_set);
optic_cli_command_add("bertcr", "bert_counter_reset", cli_bert_counter_reset);
optic_cli_command_add("omucs", "omu_cfg_set", cli_omu_cfg_set);
optic_cli_command_add("omucg", "omu_cfg_get", cli_omu_cfg_get);
optic_cli_command_add("omure", "omu_rx_enable", cli_omu_rx_enable);
optic_cli_command_add("omurd", "omu_rx_disable", cli_omu_rx_disable);
optic_cli_command_add("omute", "omu_tx_enable", cli_omu_tx_enable);
optic_cli_command_add("omutd", "omu_tx_disable", cli_omu_tx_disable);
optic_cli_command_add("omursg", "omu_rx_status_get", cli_omu_rx_status_get);
optic_cli_command_add("omutsg", "omu_tx_status_get", cli_omu_tx_status_get);
optic_cli_command_add("bosarcs", "bosa_rx_cfg_set", cli_bosa_rx_cfg_set);
optic_cli_command_add("bosarcg", "bosa_rx_cfg_get", cli_bosa_rx_cfg_get);
optic_cli_command_add("bosatcs", "bosa_tx_cfg_set", cli_bosa_tx_cfg_set);
optic_cli_command_add("bosatcg", "bosa_tx_cfg_get", cli_bosa_tx_cfg_get);
optic_cli_command_add("bosare", "bosa_rx_enable", cli_bosa_rx_enable);
optic_cli_command_add("bosard", "bosa_rx_disable", cli_bosa_rx_disable);
optic_cli_command_add("bosate", "bosa_tx_enable", cli_bosa_tx_enable);
optic_cli_command_add("bosatd", "bosa_tx_disable", cli_bosa_tx_disable);
optic_cli_command_add("bosaps", "bosa_powerlevel_set", cli_bosa_powerlevel_set);
optic_cli_command_add("bosapg", "bosa_powerlevel_get", cli_bosa_powerlevel_get);
optic_cli_command_add("bosals", "bosa_loopmode_set", cli_bosa_loopmode_set);
optic_cli_command_add("bosalg", "bosa_loopmode_get", cli_bosa_loopmode_get);
optic_cli_command_add("bosarsg", "bosa_rx_status_get", cli_bosa_rx_status_get);
optic_cli_command_add("bosatsg", "bosa_tx_status_get", cli_bosa_tx_status_get);
optic_cli_command_add("bosaasg", "bosa_alarm_status_get", cli_bosa_alarm_status_get);
optic_cli_command_add("bosaasc", "bosa_alarm_status_clear", cli_bosa_alarm_status_clear);
optic_cli_command_add("bosaicg", "bosa_int_coeff_get", cli_bosa_int_coeff_get);
optic_cli_command_add("bosasg", "bosa_stable_get", cli_bosa_stable_get);
optic_cli_command_add("calde", "cal_debug_enable", cli_cal_debug_enable);
optic_cli_command_add("caldd", "cal_debug_disable", cli_cal_debug_disable);
optic_cli_command_add("calme", "cal_mm_enable", cli_cal_mm_enable);
optic_cli_command_add("calmd", "cal_mm_disable", cli_cal_mm_disable);
optic_cli_command_add("caldsg", "cal_debug_status_get", cli_cal_debug_status_get);
optic_cli_command_add("callag", "cal_laser_age_get", cli_cal_laser_age_get);
optic_cli_command_add("calits", "cal_ibiasimod_table_set", cli_cal_ibiasimod_table_set);
optic_cli_command_add("calitg", "cal_ibiasimod_table_get", cli_cal_ibiasimod_table_get);
optic_cli_command_add("callts", "cal_laserref_table_set", cli_cal_laserref_table_set);
optic_cli_command_add("calltg", "cal_laserref_table_get", cli_cal_laserref_table_get);
optic_cli_command_add("calvts", "cal_vapd_table_set", cli_cal_vapd_table_set);
optic_cli_command_add("calvtg", "cal_vapd_table_get", cli_cal_vapd_table_get);
optic_cli_command_add("calcts", "cal_corr_table_set", cli_cal_corr_table_set);
optic_cli_command_add("calctg", "cal_corr_table_get", cli_cal_corr_table_get);
optic_cli_command_add("caltts", "cal_tcorrext_table_set", cli_cal_tcorrext_table_set);
optic_cli_command_add("calttg", "cal_tcorrext_table_get", cli_cal_tcorrext_table_get);
optic_cli_command_add("calibcs", "cal_init_bias_current_set", cli_cal_init_bias_current_set);
optic_cli_command_add("calibcg", "cal_init_bias_current_get", cli_cal_init_bias_current_get);
optic_cli_command_add("calimcs", "cal_init_mod_current_set", cli_cal_init_mod_current_set);
optic_cli_command_add("calimcg", "cal_init_mod_current_get", cli_cal_init_mod_current_get);
optic_cli_command_add("calabcg", "cal_actual_bias_current_get", cli_cal_actual_bias_current_get);
optic_cli_command_add("calamcg", "cal_actual_mod_current_get", cli_cal_actual_mod_current_get);
optic_cli_command_add("calmgs", "cal_mpd_gain_set", cli_cal_mpd_gain_set);
optic_cli_command_add("calmgg", "cal_mpd_gain_get", cli_cal_mpd_gain_get);
optic_cli_command_add("calmdgs", "cal_mpd_dbg_gain_set", cli_cal_mpd_dbg_gain_set);
optic_cli_command_add("calmdgg", "cal_mpd_dbg_gain_get", cli_cal_mpd_dbg_gain_get);
optic_cli_command_add("calmccs", "cal_mpd_cal_current_set", cli_cal_mpd_cal_current_set);
optic_cli_command_add("calmccg", "cal_mpd_cal_current_get", cli_cal_mpd_cal_current_get);
optic_cli_command_add("calmdccs", "cal_mpd_dbg_cal_current_set", cli_cal_mpd_dbg_cal_current_set);
optic_cli_command_add("calmdccg", "cal_mpd_dbg_cal_current_get", cli_cal_mpd_dbg_cal_current_get);
optic_cli_command_add("calmrcs", "cal_mpd_ref_codeword_set", cli_cal_mpd_ref_codeword_set);
optic_cli_command_add("calmrcg", "cal_mpd_ref_codeword_get", cli_cal_mpd_ref_codeword_get);
optic_cli_command_add("calmdrcs", "cal_mpd_dbg_ref_codeword_set", cli_cal_mpd_dbg_ref_codeword_set);
optic_cli_command_add("calmdrcg", "cal_mpd_dbg_ref_codeword_get", cli_cal_mpd_dbg_ref_codeword_get);
optic_cli_command_add("calmtos", "cal_mpd_tia_offset_set", cli_cal_mpd_tia_offset_set);
optic_cli_command_add("calmtog", "cal_mpd_tia_offset_get", cli_cal_mpd_tia_offset_get);
optic_cli_command_add("calmdtos", "cal_mpd_dbg_tia_offset_set", cli_cal_mpd_dbg_tia_offset_set);
optic_cli_command_add("calmdtog", "cal_mpd_dbg_tia_offset_get", cli_cal_mpd_dbg_tia_offset_get);
optic_cli_command_add("calmtof", "cal_mpd_tia_offset_find", cli_cal_mpd_tia_offset_find);
optic_cli_command_add("calmls", "cal_mpd_level_set", cli_cal_mpd_level_set);
optic_cli_command_add("calmlg", "cal_mpd_level_get", cli_cal_mpd_level_get);
optic_cli_command_add("calmlf", "cal_mpd_level_find", cli_cal_mpd_level_find);
optic_cli_command_add("calmcs", "cal_mpd_cfratio_set", cli_cal_mpd_cfratio_set);
optic_cli_command_add("calmcg", "cal_mpd_cfratio_get", cli_cal_mpd_cfratio_get);
optic_cli_command_add("calmcf", "cal_mpd_cfratio_find", cli_cal_mpd_cfratio_find);
optic_cli_command_add("calmps", "cal_mpd_powersave_set", cli_cal_mpd_powersave_set);
optic_cli_command_add("calmpg", "cal_mpd_powersave_get", cli_cal_mpd_powersave_get);
optic_cli_command_add("calfps", "cal_fcsi_predriver_set", cli_cal_fcsi_predriver_set);
optic_cli_command_add("calfpg", "cal_fcsi_predriver_get", cli_cal_fcsi_predriver_get);
optic_cli_command_add("caldavs", "cal_dcdc_apd_voltage_set", cli_cal_dcdc_apd_voltage_set);
optic_cli_command_add("caldavg", "cal_dcdc_apd_voltage_get", cli_cal_dcdc_apd_voltage_get);
optic_cli_command_add("caldcvs", "cal_dcdc_core_voltage_set", cli_cal_dcdc_core_voltage_set);
optic_cli_command_add("caldcvg", "cal_dcdc_core_voltage_get", cli_cal_dcdc_core_voltage_get);
optic_cli_command_add("calddvs", "cal_dcdc_ddr_voltage_set", cli_cal_dcdc_ddr_voltage_set);
optic_cli_command_add("calddvg", "cal_dcdc_ddr_voltage_get", cli_cal_dcdc_ddr_voltage_get);
optic_cli_command_add("callds", "cal_laser_delay_set", cli_cal_laser_delay_set);
optic_cli_command_add("calldg", "cal_laser_delay_get", cli_cal_laser_delay_get);
optic_cli_command_add("calmdcs", "cal_mm_dark_corr_set", cli_cal_mm_dark_corr_set);
optic_cli_command_add("calmdcg", "cal_mm_dark_corr_get", cli_cal_mm_dark_corr_get);
optic_cli_command_add("calmdcf", "cal_mm_dark_corr_find", cli_cal_mm_dark_corr_find);
optic_cli_command_add("calfg", "cal_fusing_get", cli_cal_fusing_get);
optic_cli_command_add("calts", "cal_tscalref_set", cli_cal_tscalref_set);
optic_cli_command_add("caltg", "cal_tscalref_get", cli_cal_tscalref_get);
optic_cli_command_add("calcog", "cal_current_offset_get", cli_cal_current_offset_get);
optic_cli_command_add("calros", "cal_rx_offset_set", cli_cal_rx_offset_set);
optic_cli_command_add("calrog", "cal_rx_offset_get", cli_cal_rx_offset_get);
optic_cli_command_add("calrof", "cal_rx_offset_find", cli_cal_rx_offset_find);
}

/*! @} */

#endif
